package com.psmreborn.nopsmdrm;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;

import java.io.File;
import java.io.IOException;

import eu.chainfire.libsuperuser.Shell;

public class FixPermissions {
    public static void changePermissionsToPsm(Activity ctx) {
        ProgressDialog dialog = new ProgressDialog(ctx);
        dialog.setTitle("Fixing permissions ...");
        dialog.setMessage("Please Wait ...");
        dialog.setIndeterminate(true);
        dialog.setCancelable(false);
        dialog.show();

        new Thread(() -> {
            Handler handler = new Handler(ctx.getMainLooper());

            Helper.killPsm();
            String androidDataFolder = new File(new File(Environment.getExternalStorageDirectory(), "Android"), "data").getAbsolutePath();
            try {
                String groupId = Root.getFileGroup(androidDataFolder);
                String userId = String.valueOf(Helper.getPsmAppInfo().uid);
                Root.chownRoot(new File(new File(new File(androidDataFolder, "com.playstation.psstore"), "files"), "psm").getAbsolutePath(), userId, groupId);

                handler.post(() -> {
                    dialog.dismiss();
                    new AlertDialog.Builder((Activity)ctx)
                            .setTitle("Success!")
                            .setMessage("Successfully updated file permissions")
                            .setCancelable(false)
                            .setPositiveButton("Ok", null).show();
                });
            } catch (Exception e) {
                handler.post(() -> {
                    dialog.dismiss();
                    new AlertDialog.Builder((Activity)ctx)
                            .setTitle("Failed.")
                            .setMessage(e.toString())
                            .setCancelable(false)
                            .setPositiveButton("Ok", null).show();
                });
            }
        }).start();
    }
}
